Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members

# TAO_SSLIOP_Profile Class Reference

This class defines the protocol specific attributes required for locating ORBs over a TCP/IP network, using either IIOP or IIOP/SSL for communication. More...

`#include <SSLIOP_Profile.h>`

Inheritance diagram for TAO_SSLIOP_Profile:

[legend]
Collaboration diagram for TAO_SSLIOP_Profile:

[legend]
List of all members.

## Public Methods
| TAO_SSLIOP_Profile (const ACE_INET_Addr &addr, const TAO_ObjectKey &object_key, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core, const SSLIOP::SSL *ssl_component)
| Profile constructor, same as above except the object_key has already been marshaled. More...
| TAO_SSLIOP_Profile (const char *host, CORBA::UShort port, const TAO_ObjectKey &object_key, const ACE_INET_Addr &addr, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core, const SSLIOP::SSL *ssl_component)
| Profile constructor, this is the most efficient since it doesn't require any address resolution processing. More...
| TAO_SSLIOP_Profile (TAO_ORB_Core *orb_core, const SSLIOP::SSL *ssl_component)
| Create profile with the given SSLIOP tagged component. More...
| TAO_SSLIOP_Profile (TAO_ORB_Core *orb_core)
| Profile constructor, default. More...
| ~TAO_SSLIOP_Profile (void)
| Destructor is to be called only through _decr_refcnt(). More...
virtual int | decode (TAO_InputCDR &cdr)
| Encodes this profile's endpoints into a tagged component. More...
virtual int | encode_endpoints (void)
virtual CORBA::Boolean | is_equivalent (const TAO_Profile *other_profile)
virtual TAO_Endpoint * | endpoint (void)
| Return pointer to the head of this profile's endpoints list, i.e., <ssl_endpoint_> accessor. More...
virtual void | parse_string (const char *string ACE_ENV_ARG_DECL)
| Override parse_string() from the base class to update the ssl endpoint's iiop endpoint once the base class has completed parsing the string. More...
void | add_endpoint (TAO_SSLIOP_Endpoint *endp)
| Add <end. More...
## Private Methods
int | decode_endpoints (void)
| Helper for <decode>. More...
## Private Attributes
TAO_SSLIOP_Endpoint | ssl_endpoint_
| Head of this profile's list of endpoints. More...

## Detailed Description

This class defines the protocol specific attributes required for locating ORBs over a TCP/IP network, using either IIOP or IIOP/SSL for communication.

This class extends TAO_IIOP_Profile to support secure communication using SSL.

## Constructor & Destructor Documentation

TAO_SSLIOP_Profile::TAO_SSLIOP_Profile | ( | const ACE_INET_Addr & | addr,
|  | const TAO_ObjectKey & | object_key,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core,
|  | const SSLIOP::SSL * | ssl_component
| ) |

| Profile constructor, same as above except the object_key has already been marshaled.

TAO_SSLIOP_Profile::TAO_SSLIOP_Profile | ( | const char * | host,
|  | CORBA::UShort | port,
|  | const TAO_ObjectKey & | object_key,
|  | const ACE_INET_Addr & | addr,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core,
|  | const SSLIOP::SSL * | ssl_component
| ) |

| Profile constructor, this is the most efficient since it doesn't require any address resolution processing.

TAO_SSLIOP_Profile::TAO_SSLIOP_Profile | ( | TAO_ORB_Core * | orb_core,
|  | const SSLIOP::SSL * | ssl_component
| ) |

| Create profile with the given SSLIOP tagged component.

TAO_SSLIOP_Profile::TAO_SSLIOP_Profile | ( | TAO_ORB_Core * | orb_core | ) |

| Profile constructor, default.

TAO_SSLIOP_Profile::~TAO_SSLIOP_Profile | ( | void |  | ) |

| Destructor is to be called only through _decr_refcnt().

## Member Function Documentation

void TAO_SSLIOP_Profile::add_endpoint | ( | TAO_SSLIOP_Endpoint * | endp | ) |

| Add <end. p> to this profile's list of endpoints (it is inserted next to the head of the list). This profiles takes ownership of <endp>. If <endp>'s <iiop_endpoint_> member is not 0, it is added to our parent's class endpoint list.

int TAO_SSLIOP_Profile::decode | ( | TAO_InputCDR & | cdr | ) | `[virtual]`

| Encodes this profile's endpoints into a tagged component. This is done only if RTCORBA is enabled, since currently this is the only case when we have more than one endpoint per profile. Return 0 on success, -1 on failure. SSL endpoints are transmitted using TAO-proprietary tagged component. Component tag is TAO_TAG_SSL_ENDPOINTS and component data is an encapsulation of a sequence of structs, each representing a single endpoint. Data format is specified in ssl_endpoins.pidl. Reimplemented from TAO_IIOP_Profile.

int TAO_SSLIOP_Profile::decode_endpoints | ( | void |  | ) | `[private]`

| Helper for <decode>. Decodes endpoints from a tagged component. Decode only if RTCORBA is enabled. Return 0 on success and -1 on failure. Reimplemented from TAO_IIOP_Profile.

int TAO_SSLIOP_Profile::encode_endpoints | ( | void |  | ) | `[virtual]`

| Reimplemented from TAO_IIOP_Profile.

TAO_Endpoint * TAO_SSLIOP_Profile::endpoint | ( | void |  | ) | `[virtual]`

| Return pointer to the head of this profile's endpoints list, i.e., <ssl_endpoint_> accessor. Reimplemented from TAO_IIOP_Profile.

CORBA::Boolean TAO_SSLIOP_Profile::is_equivalent | ( | const TAO_Profile * | other_profile | ) | `[virtual]`

| Reimplemented from TAO_IIOP_Profile.

virtual void TAO_SSLIOP_Profile::parse_string | ( | const char *string | ACE_ENV_ARG_DECL | ) | `[virtual]`

| Override parse_string() from the base class to update the ssl endpoint's iiop endpoint once the base class has completed parsing the string. Initialize this object using the given input string. Url-style string contain only one endpoint. Reimplemented from TAO_IIOP_Profile.

## Member Data Documentation

TAO_SSLIOP_Endpoint TAO_SSLIOP_Profile::ssl_endpoint_`[private]`

| Head of this profile's list of endpoints. This endpoint is not dynamically allocated because a profile always contains at least one endpoint. Currently, a profile contains more than one endpoint, i.e., list contains more than just the head, only when RTCORBA is enabled. However, in the near future, this will be used in nonRT mode as well, e.g., to support TAG_ALTERNATE_IIOP_ADDRESS feature. Since SSLIOP profile is an extension of IIOP profile, its addressing info is contained in two places: IIOP parent class contains all iiop addressing while this class contains ssl-specific addressing additions to iiop. This means that there are two lists of endpoints: one maintained in the parent class and one maintained here. Each ssl endpoint maintains a pointer to its counterpart in the parent class endpoint list. For transmission of iiop addressing information, see TAO_IIOP_Profile. Addressing info of the default ssl endpoint, i.e., head of the list, is transmitted using standard SSLIOP::TAG_SSL_SEC_TRANS tagged component. See <encode_endpoints> method documentation above for how the rest of the ssl endpoint list is transmitted.

The documentation for this class was generated from the following files:

- SSLIOP_Profile.h
- SSLIOP_Profile.cpp